#lang slideshow

(require slideshow/code)
(require "fonctions.ss")

; #####################
;
; aide à l'installation
; de fluxus sous mac
; et ubuntu
;
; #####################



; splashscreen
(splash)

; premier chapitre
(chapitrage1 'présentation)

(slide
 (para/center "Ce slideshow présente brièvement Fluxus, et expliquera pas à pas son installation ainsi que celle de ses dépendances sous GNU/Linux et Mac OS 10.5.")
 (para/center "Puis une aide sur l'installation des applications requises pour l'utilisation de sons sous Fluxus.")
 (para/center "Enfin une présentation de quelques modules de Fluxus à l'aide d'exemples tirés du cours de Programmation Fonctionnelle de Mr Roy."))

(slide
 #:title "Qu'est ce que Fluxus ?"
 (item "Fluxus est un environnement permettant la création de scripts et leurs execution à la volée. Sa principale utilisation est la programmation en temps réel de scènes graphiques devant un public.")
 'next
 (item "La création de scripts est intuitive et très rapide.")
 'next
 (item "Possède de nombreux modules qui étendent ses possibilités.")
 'next
 (item "Il fonctionne sous GNU/Linux et Mac OS 10.5.")
 'next
 (item "Le langage de programmation utilisé pour coder dans Fluxus est Scheme."))

(slide
 #:title "Pourquoi Scheme ?"
 #:layout 'top
 (para "Scheme est un langage de programmation fonctionnel qui permet le prototypage rapide de fonctions. Le développement est donc optimisé. De plus il est très approprié:")
 'next
 (item "au graphisme (utilisation d'OpenGl qui fonctionne sur le même principe.)")
 'next
 (item "à la programmation en temps réel.")
 'next
 (item "au prototypage de fonctions."))

(slide
 #:title "Pourquoi Scheme ?"
 #:layout 'top
 (para "Compte tenu de la puissance de calcul des consoles actuellement, la programmation de jeux vidéo commerciaux y est très approprié, entre autres:")
 'next
 (item "Crash Bandicoot")
 (subitem "PlayStation 1 et 2")
 'next
 (item "Jak & Daxter")
 (subitem "PlayStation 2 et 3")
 'next
 (item "Mario 64")
 (subitem "Nintendo 64")
 'next
 (item "Uncharted")
 (subitem "PlayStation 3"))


(slide
 #:title "Prérequis"
 (para "Même si coder avec Fluxus est assez intuitif, il est préférable de connaître les bases du langage Scheme ou encore mieux, avoir suivi le cours de Programmation Fonctionnelle de Mr Roy.")
 (para "Vous pourrez vous référencer à l'autre slideshow qui propose une brève introduction au langage Scheme."))

(slide
 #:title "Les dépendances de Fluxus"
 (para/center "De par sa nature, Fluxus repose sur plusieurs technologies. Et pour étendre ses possibilités, il dépend de beaucoup de librairies et d'autres applications. C'est ce qu'on apelle les dépendances d'une application.")
 'next
 (para "Par exemple pour l'utilisation d'images, il faudra installer les librairies:")
 (subitem "jpeg")
 (subitem "libpng")
 'next
 (para "De plus Fluxus nécessite une version spécifique pour chaque dépendance, il faudra donc faire attention à la version que vous installerez."))

(slide
 #:title "Pourquoi compiler ?"
 (para/center "Vous pouvez bien évidement installer Fluxus à partir de paquets ou de binaires précompilés (Ubuntu, Fedora, Mac OS 10.5), ces paquets sont disponibles sur le site de Fluxus:")
 'next
 (cmd "http://www.pawfal.org/fluxus/packages/")
 'next
 (para/center "Mais le mieux est encore de le compiler soit même, car Fluxus est en perpetuelle évolution et corrige certains bugs."))

(slide
 #:title "Pure:dyne"
 (para/center "Il existe une distribution en Live-cd qui permet d'essayer plusieurs logiciels dédiés à la création graphique et audio sans avoir à les installer, Pure:Dyne disponible à cette adresse:")
 (cmd "http://code.goto10.org/projects/puredyne/"))


; chapitre 2
(chapitrage1 'deplinux)

(slide
 #:title "Installation des dépendances sous GNU/Linux"
 #:layout 'top
 (para "Voici les principales dépendances de Fluxus. Il faudra installer une version au moins égale à celle indiquée:")
 (blank)
 (item "OpenGl")
 (item "Ode version 0.5")
 (item "PLT Scheme version 4.x")
 (item "fftw version 3.0.1")
 (item "jack version 1.0")
 (item "libsndfile version 1.0.12")
 (item "liblo version 0.5.0")
 (item "glew version 1.3.4"))

(slide
 #:title "Installation des dépendances sous GNU/Linux"
 #:layout 'top
 (para "Nous partirons de la distribution Ubuntu 8.10, car elle est stable et facile d'utilisation. De plus ses dépôts sont assez récent, ce qui va beaucoup nous aider !"))

(slide
 #:title "Installation des dépendances sous GNU/Linux"
 #:layout 'top
 (para "A partir d'un terminal, nous allons créer un répertoire dans lequel nous travaillerons:")
 (cmd ">mkdir sources")
 'next
 (para "Puis déplacons nous dans sources/ :")
 (cmd ">cd sources/")
 'next
 (para "Installons les applications nécessaire à la récupération et la compilation de nos codes sources:")
 (para
  (cmd ">sudo apt-get install automake autotools-dev gcc")
  (cmd "g++ libxaw7-dev libjpeg62-dev libpng4-dev libglut3-dev")
  (cmd "libasound2-dev subversion git-core scons wget"))
 (it "sudo est la commande qui servira à utiliser les droits administrateurs,")
 (it "il faudra donc entrer votre mot de passe"))

(slide
 #:title "Installation des dépendances sous GNU/Linux"
 #:layout 'top
 (para "Téléchargeons le code source d'Ode:")
 (cmd-sized 20 ">svn co https://opende.sourceforge.net/svnroot/opende opende")
 'next
 (para "Déplacons nous dans le répertoire crée:")
 (cmd "cd opende/trunk/")
 'next
 (para "Il faudra \"bootstrapper\" le code source pour qu'il soit amorçable:")
 (cmd ">sh autogen.sh")
 'next
 (para "Puis il faudra faire un paramètrage des options pour que la configuration se passe bien:")
 (cmd ">./configure")
 'next
 (para "On compile le code source:")
 (cmd ">make"))

(slide
 #:title "Installation des dépendances sous GNU/Linux"
 #:layout 'top
 (para "enfin, procédons à l'installation:")
 (cmd ">sudo make install")
 'next
 (para "Ode est installé, passons à fftw, revenons à la raçine de notre répertoire sources:")
 (cmd ">cd ~/sources/")
 'next
 (para "Téléchargeons le code source, il est disponible à cette adresse:")
 (cmd "http://www.fftw.org/download.html")
 (para "Prenez la dernière version stable disponible et copiez là dans notre répertoire sources. Vous pouvez sinon essayer cette commande, qui devrait vous le télécharger dans le répertoire courant:")
 (cmd ">wget http://www.fftw.org/fftw-3.2.1.tar.gz"))

(slide
 #:title "Installation des dépendances sous GNU/Linux"
 #:layout 'top
 (para "Décompressez l'archive:")
 (cmd ">tar -xf fftw-3.2.1.tar.gz")
 'next
 (para "Puis déplacez vous à l'intérieur:")
 (cmd ">cd fftw-3.2.1/")
 'next
 (para "On réitère les opérations faites avec Ode:")
 (para
  (cmd ">./configure")
  (cmd ">make")
  (cmd ">sudo make install"))
 'next
 (para "Maintenant passons à liblo. On retourne à la raçine de notre répertoire sources")
 (cmd ">cd ~/sources/"))

(slide
 #:title "Installation des dépendances sous GNU/Linux"
 #:layout 'top
 (para "On récupère le code source:")
 (cmd-sized 18 ">svn: co https://liblo.svn.sourceforge.net/svnroot/liblo liblo")
 'next
 (para "On se déplace à l'intérieur:")
 (cmd ">cd liblo/trunk/")
 'next
 (para "On \"bootstrappe\" le code source:")
 (cmd ">sh autogen.sh")
 'next
 (para "Et on réitère les opérations faites sur fftw:")
 (para
  (cmd ">./configure")
  (cmd ">make")
  (cmd ">sudo make install")))

(slide
 #:title "Installation des dépendances sous GNU/Linux"
 #:layout 'top
 (para "On continue avec l'installation de libsndfile. On récupère le code source stable le plus récent ici:")
 (cmd "http://www.mega-nerd.com/libsndfile/#Download")
 (para "Ou vous pouvez le faire directement avec wget:")
 (cmd-sized 18 ">wget http://www.mega-nerd.com/libsndfile/libsndfile-1.0.19.tar.gz")
 'next
 (para "décompressez l'archive:")
 (cmd ">tar -xf libsndfile-1.0.19.tar.gz")
 'next
 (para "puis déplacez vous à l'intérieur:")
 (cmd ">cd ~/sources/libsndfile-1.0.19/")
 'next
 (para "on compile et on installe:")
 (para 
  (cmd ">./configure")
  (cmd ">make")
  (cmd ">sudo make install")))

(slide
 #:title "Installation des dépendances sous GNU/Linux"
 #:layout 'top
 (para "Procédons maintenant à l'installation de PLT Scheme. Retournons à la racine de notre dossier sources et téléchargeons le code source:")
 (para
  (cmd ">cd ~/sources/")
  (cmd ">svn co http://svn.plt-scheme.org/plt/trunk plt"))
 'next
 (para "Déplacons nous à l'intérieur:")
 (cmd ">cd plt/src/")
 'next
 (para "Puis configurons les options de compilation:")
 (cmd ">./configure --enable-shared --prefix=/usr/local")
 'next
 (para "Puis compilons:")
 (cmd ">make")
 'next
 (para "Enfin lançons l'installation:")
 (cmd ">sudo make install"))



(slide
 #:title "Installation des dépendances sous GNU/Linux"
 (para "Avant de passer à l'installation de Fluxus, nous allons installer Jack ainsi qu'une interface graphique pour l'utiliser:")
 (cmd ">sudo apt-get install jackd qjackctl")
 'next
 (para "Nous utiliserons cette application dans la partie audio de ce slideshow."))



; chapitre 3
(chapitrage1 'fluxlinux)

(slide
 #:title "Installation de Fluxus sous GNU/Linux"
 #:layout 'top
 (para "On va récupérer le code source:")
 (para
  (cmd ">cd ~/sources/")
  (cmd ">git clone git://git.savannah.nongnu.org/fluxus.git"))
 'next
 (para "Puis nous allons compiler le code. Si vous possedez un chipset graphique ne gérant pas les Shaders matériels, il faudra désactiver leur support, de même pour le multitexturing.")
 (para "Pour une compilation normale:")
 (cmd ">scons")
 (para "Pour une compilation sans le support des Shaders matériels:")
 (cmd ">scons GLSL=0"))

(slide
 #:title "Installation de Fluxus sous GNU/Linux"
 (para "Pour une compilation sans le support du multitexturing:")
 (cmd ">scons MULTITEXTURE=0")
 'next
 (para "Normalement un scons suffirait mais il se pourrait que le script ne détecte pas une librairie requise lors de la compilation, il est donc préférable d'expliciter ces options le cas échéant !"))


(slide
 #:title "Installation de Fluxus sous GNU/Linux"
 (para "Puis on pourra finalement installer Fluxus:")
 (cmd ">sudo scons install")
 'next
 (para "De même si vous avez eu à expliciter la désactivation d'une option lors de la compilation, il faudra encore l'indiquer avant install, par exemple:")
 (para
  (cmd ">scons MULTITEXTURE=0 GLSL=0")
  (cmd ">sudo scons MULTITEXTURE=0 GLSL=0 install"))
 (para "Ici, j'ai désactivé le multitexturing et le support des Shaders matériels à la compilation, puis à l'installation."))

;(define coding (lambda (s) (text s (current-code-font) (current-font-size))))

(slide
 #:title "Installation de Fluxus sous GNU/Linux"
 (para "Vous pouvez maintenant lancer Fluxus, qui a été installé dans /usr/local/bin/ donc à partir d'une console vous pourrez le lancer:")
 (cmd ">fluxus")
 (para "Vous pourrez éventuellement lancer une série de test qui déterminerons s'il existe des erreurs dans les fonctions de Fluxus. Dans le toplevel de Fluxus il faudra taper:")
 (para
  (code (self-test #f))))



; chapitre 4
(chapitrage1 'depmac)

(slide
 #:title "Installation des dépendances sous Mac OS 10.5"
 (para "Comme Mac OS X est basé sur Unix, l'installation est presque la même que sous GNU/Linux. Il faudra néamoins installer un gestionnaire de paquets, à l'instar d'aptitude sous Ubuntu par exemple.")
 'next
 (para "Il existe deux gestionnaires de paquets particulièrement utilisés:")
 'next
 (item "Fink")
 'next
 (item "Macports")
 'next
 (para "Nous choisirons macports. Si vous n'êtes pas très à l'aise avec le terminal, vous pourrez installer une interface graphique à celui ci."))


(slide
 #:title "Installation des dépendances sous Mac OS 10.5"
 (para "Macports requiert que les outils de développement d'Apple soient installés. L'environnement Xcode est disponible gratuitement sur le site d'Apple:")
 (cmd "http://developer.apple.com/tools/xcode/")
 (para "Prenez la dernière version disponible (3.x)")
 (blank)
 (para "Il est aussi disponible sur votre DVD d'installation de Mac OS X, mais il faudra le mettre à jour."))

(slide
 #:title "Installation des dépendances sous Mac OS 10.5"
 (para "Il faudra de plus installer l'environnement graphique X11 et son SDK. Il est disponible sur le site de developpement d'Apple cité précédement. Il est aussi sur votre DVD d'installation de Mac OS X, mais il faudra aussi le mettre à jour."))

(slide
 #:title "Installation des dépendances sous Mac OS 10.5"
 (para "Vous pouvez maintenant installer Macports. Il est disponible à cette adresse:")
 (cmd "http://www.macports.org/install.php")
 'next
 (para "Quand macports serra installé, il faudra le mettre à jour. Comme c'est une application en mode console, il faudra utiliser un terminal pour l'utiliser. Sous Mac OS 10.5, le terminal se situe dans votre disque dur système, dans le répertoire Applications/Utilitaires.")
 'next
 (para "Glissez le sur votre Dock car vous l'utiliserez assez souvent à partir de maintenant."))

(slide
 #:title "Installation des dépendances sous Mac OS 10.5"
 #:layout 'top
 (blank)
 (para "A l'ouverture du terminal, vous serrez dans votre dossier personnel. Nous allons appeler macports et lui dire se de mettre à jour.")
 (cmd ">sudo port -v selfupdate")
 'next
 (para "Profitons en pour créer un répertoire de travail, nous y téléchargerons le code source de Fluxus en temps voulu.")
 (cmd ">mkdir ~/sources")
 'next
 (para "Puis déplaçons nous à l'intérieur:")
 (cmd ">cd ~/sources/"))

(slide
 #:title "Installation des dépendances sous Mac OS 10.5"
 #:layout 'top
 (para "Depuis peu, il est possible de se passer de la compilation de PLT Scheme, on peut donc le télécharger directement à partir de leur site:")
 (cmd "http://download.plt-scheme.org/drscheme/")
 'next
 (para "Installez le, puis modifiez votre fichier .profile situé dans votre dossier personnel. Il faudra en fait exporter le chemin d'acces à PLT Scheme dans votre PATH. Pour cela copiez ces deux lignes dans votre fichier .profile.")
 (para "Attention, c'est un fichier caché, donc c'est normal que vous ne le voyez pas avec le finder, il faudra passer par Emacs ou directement dans la console avec nano par exemple. Installez nano comme cela:")
 (cmd ">sudo port install nano"))

(slide
 #:title "Installation des dépendances sous Mac OS 10.5"
 (blank)
 (para "Puis ouvrez votre fichier .profile:")
 (cmd ">nano .profile")
 (blank)
 'next
 (para "Rajoutez y les deux lignes suivantes:")
 (cmd-sized 14 "export PATH=\"opt/local/bin:/opt/local/sbin:Applications/PLT\\ Scheme\\ v4.1.x/bin/:$PATH\"")
 (cmd-sized 14 "export DYLD_FRAMEWORK_PATH=/Applications/PLT\\ Scheme\\ v4.1.x/lib/\"")
 'next
 (para "on sauvegarde avec les touches Ctrl+o, on valide le nom de fichier et on quitte nano avec Ctrl+x"))

(slide
 #:title "Installation des dépendances sous Mac OS 10.5"
 (para "Maintenant nous allons installer les dépendances avec macports:")
 (para
  (cmd ">sudo port install fftw-3 glew freetype jack jpeg liblo")
  (cmd "libpng libsndfile ode scons tiff zlib git-core"))
 'next
 (para "Maintenant passons à l'installation de Fluxus !"))

(slide
 #:title "Installation de Fluxus sous Mac OS 10.5"
 (para "Nous allons récupérer le code source de Fluxus:")
 (cmd ">git clone git://git.savannah.nongnu.org/fluxus.git")
 'next
 (para "Déplaçons nous dans le répertoire crée:")
 (cmd ">cd fluxus")
 'next
 (para "Nous allons maintenant compiler Fluxus."))



; chapitre 5
(chapitrage1 'fluxmac)

(slide
 #:title "Installation de Fluxus sous Mac OS 10.5"
 #:layout 'top
 (para "Comme sous GNU/Linux, il est préférable de désactiver les options qui ne sont pas supportées par votre carte graphique, même si très recément cette procédure à été automatisée, elle est encore assez instable. On explicitera donc ces options lors de la compilation:")
 (cmd ">scons")
 'next
 (para "Par exemple, sur mon macbook j'ai du compiler en désactivant le multitexturing et les Shaders matériels car le pilote d'Apple pour mon chipset graphique ne supporte pas pleinement l'OpenGl2:")
 (cmd ">scons MULTITEXTURE=0 GLSL=0"))

(slide
 #:title "Installation de Fluxus sous Mac OS 10.5"
 (para "De même pour l'installation:")
 (cmd ">sudo scons install")
 'next
 (para "Sur mon macbook, j'ai donc dû taper:")
 (cmd ">sudo scons MULTITEXTURE=0 GLSL=0 install"))

